
var TickSystem = require('./TickSystem.js');
var Entity = require('./Entity.js');
var System = require('./System.js');

function DECS() {
	TickSystem.call(this);
	this.entities = {};
}

DECS.create = function() {
	return new DECS();
}

DECS.createEntityClass = Entity.createClass;

DECS.createSystemClass = function() {
	var Constructor = function() {};
	var props = {};

	Array.prototype.forEach.call(arguments, function(arg) {
		if (typeof arg === 'function') {
			Constructor = arg;
		} else if (typeof arg === 'object') {
			props = arg;
		}
	});

	return function() {
		var system = new System(props);
		system.constructor = Constructor;
		Constructor.apply(system, arguments);
		return system;
	};
};

DECS.prototype = new TickSystem();
DECS.prototype.stop();

module.exports = DECS;
