
var System = require('./System.js');
var now = require('./now.js');

function TickSystem() {
	System.call(this);
	this.start();
}

TickSystem.create = function() {
	return new TickSystem();
};

TickSystem.prototype = new System({
	_running: false,
	tickAll: function() {
		var time = now();
		var delta = time - this._lastTime;
		this._lastTime = time;
		System.prototype.tickAll.call(this, delta);
	},	
	start: function() {
		if (!this._running) {
			this._running = true;
			this._lastTime = now();
			this._intrvl = setInterval(
				function() {
					this.tickAll();
				}.bind(this),
				20
			);
		}
	},
	stop: function() {
		if (this._running) {
			this._running = false;
			clearInterval(this._intrvl);
			delete this._intrvl;
		}
	}
});

module.exports = TickSystem;
