
var DECS = require('../');
var Player = require('./Player.js');

var game = DECS.create();

var schoolSize = 10;

function randomEntityId(entities) {
	var keys = Object.keys(entities);
	return entities[keys[Math.floor(Math.random() * keys.length)]].id;
}

var playerManager = game.addSystem('playerManager', {
	tick: function(ms) {
		if (game.countEntities() < schoolSize && Math.random() < .01) {
			this.addPlayer();
			if (game.countEntities() >= schoolSize) {
				console.info('School is full!');
			}
		}
	},
	addPlayer: function() {
		var player = new Player();
		var player = game.addEntity(player);
		console.info(player.name + ' has started school!');
	}
});

var friendManager = game.addSystem('friendManager', {
	tick: function(ms) {
		game.eachEntity(function(entity) {
			var component = entity.getComponent('bestFriend');
			var n = Math.random();
			if (n < .01) {
				var bestFriend = game.getEntity(component.bestFriendId);
				if (bestFriend) {
					delete component.bestFriendId;
					console.info(entity.name + ' is no longer best friends with ' + bestFriend.name);
				}
			} else if (n < .02) {
				if (!bestFriend) {
					var bestFriendId = randomEntityId(game.entities);
					if (bestFriendId !== entity.id) {
						component.bestFriendId = randomEntityId(game.entities);
						bestFriend = game.getEntity(component.bestFriendId);
						console.info(entity.name + ' is now best friends with ' + bestFriend.name);
					}
				}
			}
		});
	}
});
